using System.Diagnostics;
using System;
//using System.Xml.Linq;
	using System.Windows.Forms;
using System.Collections;
using System.Drawing;
using Microsoft.VisualBasic;
using System.Data;
using System.Collections.Generic;
using AxCopyController02;

//****************************************** HELP
//RCK1.P_ProgramID (e.g. "4AD14721F3698705BA618E2C" )
//   * Activation Key encryption logic will depend on this key
//   * ProgramID Must have 24 Characters
//   * All Characters of ProgramID Must be 0 To 9 OR 'A' To 'F'
//
//RCK1.P_Sequence (e.g. "ABCDEFGHIJKLMNOPQRSTUVWXYZ" this is default value)
//   * for advance protection use this property otherwise not require
//   * Sequence String length Must be 26 characters
//   * All characters must be between ('A' to 'Z') OR (0 to 9)
//   * No character must repeat
//   * Here output character Key(Activation Code Or MID Code) is map as "A as A,B as B,
//       C as C....as on Z as Z". you can change maping value as per your requirement
//   * E.g.
//          RCK1.P_Sequence = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
//          RCK1.P_Sequence = "ABCDEFGHIJKLMNOPQ123456789"
//          RCK1.P_Sequence = "ZYXWVUTSRQPONMLKJIHGFEDCBA"
//
//RCK1.P_SoftwareID (e.g. 1 is Default value)
//   *   If you have more than 1 software use this property(if you changed P_ProgramID in
//       all your softwares then you don't set this property)
//   * SoftwareID Must Be Between 1 To 26
//   * E.g.
//           RCK1.P_SoftwareID = 1 (For School Software)
//           RCK1.P_SoftwareID = 2 (For Account Software)
//           RCK1.P_SoftwareID = 3 (For Payslip)
//
//############### NOTE ################
//IN DEMO VERSION
//YOU CAN NOT CHANGE VALUE OF FOLLOWING PROPERTY. VALUE OF FOLLOWING PROPERTY IS READONLY IN DEMO VERSION
//   RCK1.P_ProgramID = "0123456789ABCDEF01234567"
//   RCK1.P_Sequence = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
//   RCK1.P_SoftwareID = 1
//#####################################
//******************************************
namespace YourSchoolApp
{
	public partial class FrmRegistrationForm
	{
		public FrmRegistrationForm()
		{
			InitializeComponent();
			if (defaultInstance == null)
				defaultInstance = this;
		}
		
#region Default Instance
		
		private static FrmRegistrationForm defaultInstance;
		public static FrmRegistrationForm Default
		{
			get
			{
				if (defaultInstance == null)
				{
					defaultInstance = new FrmRegistrationForm();
					defaultInstance.FormClosed += new FormClosedEventHandler(defaultInstance_FormClosed);
				}
				
				return defaultInstance;
			}
		}
		
		static void defaultInstance_FormClosed(object sender, FormClosedEventArgs e)
		{
			defaultInstance = null;
		}
		
#endregion
		bool IsUnload;
		
		public void Form1_Load(System.Object sender, System.EventArgs e)
		{
            Module1.AppStatus = -100; //For application status is demo
			RCK1.P_ProgramID = "0123456789ABCDEF01234567"; // Activation Key encryption logic will depend on this key
			RCK1.P_Sequence = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"; // enter Sequence charactors. output character Key(Activation Code Or MID Code) is map as "A as A,B as B,C as C....as on Z as Z" but you can change this sequence by this parameter (e.g. ABCDEFGHIJKLMNOPQ123456789 )
			RCK1.P_SoftwareID = 1; // 1 For School Software, 2 For Account Software, 3 For Payslip ...As on
			
			string ActivationCode;
			TxtMID.Text = (string) RCK1.P_GetMID1; // Return Mid code
			ActivationCode = (string) (RCK1.M_GetActCode1FromRCKLIC1_DLL((new Microsoft.VisualBasic.ApplicationServices.WindowsFormsApplicationBase()).Info.DirectoryPath)); //Read Activation Code from (App.Path & "RCKLIC1.DLL")
			if (ActivationCode != "")
			{
				CheckActivation(ActivationCode, false); // Unprotect activation code
			}
			IsUnload = false;
			if (Module1.AppStatus == 0) // if license copy
			{
				this.Width = 2;
				this.Height = 2;
				this.Top = -10;
				this.Left = -10;
				IsUnload = true;
			}
		}
		
		public void FrmRegistrationForm_Activated(object sender, System.EventArgs e)
		{
			if (IsUnload)
			{
				this.Close();
			}
		}
		
		private void CheckActivation(string ActivationCode, bool IsDisplayMessage)
		{
			//this function unprotect activation code and match Hardware serial no detail with client PC
			//Parameter Description
			//ActivationCode     ->  Pass activation code
			//IsDisplayMessage   ->  Pass True for if you want to display error message
			
			string UniqueID = "";
			short SoftwareID = 0;
			int ErrorNo;
			bool IsCreateRCKLIC1_DLL = true;
			//if activation code unprotect success and then Activation code will save to (App.Path & "RCKLIC1.DLL")
			ErrorNo = System.Convert.ToInt32(RCK1.M_UnprotectAct1(ActivationCode,ref UniqueID,ref SoftwareID, (new Microsoft.VisualBasic.ApplicationServices.WindowsFormsApplicationBase()).Info.DirectoryPath,ref IsCreateRCKLIC1_DLL));
			//Parameters description
			//ActivationCode		                ->	Pass Activation Code
			//UniqueID		 	                ->	Return UNIQUE ID
			//SoftwareID	 		                ->	Return Software ID
			//My.Application.Info.DirectoryPath	->	Pass exe path (e.g. 'D:\School01') where it saves
			//						                Activation Code in RCKLIC1.DLL file
			//IsCreateRCKLIC1_DLL                ->  Pass True, if activation code successfully unprotect
			//						                then Activation code will save to (My.Application.Info.DirectoryPath & "RCKLIC1.DLL")
			//Function return 0 For Activation Code unprotect Successfully
			
			if (IsDisplayMessage)
			{
				switch (ErrorNo)
				{
					case -1:
						Interaction.MsgBox("Entering 16 characters of Activation Code",MsgBoxStyle.OkOnly , "My App");
						break;
					case -2:
						Interaction.MsgBox("Every Character of Activation Code must be between \'A\' to \'Z\'",MsgBoxStyle.OkOnly, "My App");
						break;
						//As per your RCK1.SequenceNo
						//(e.g. if RCK1.SequenceNo = 'ABCDEFGHIJKLMNOP0123456789' then 'A' to 'P' OR 0 TO 9)
					case -3:
						MessageBox.Show("Invalid Activation code(Typing mistake) or this Activation Code is not for this application ");
						break;
					case -4:
						//UniqueID(Macaddress,Motherboard No,HDD ID... as on) of Activation code is not match with UniqueID of MID Code
						MessageBox.Show("Invalid Activation Code (Error -4)");
						break;
					case -5:
						//SoftwareID(1 to 26) of Activation Code is not match with SoftwareID of MID Code
						MessageBox.Show("Invalid Activation Code (Error -5)");
						break;
					case 0:
						MessageBox.Show("Successs");
						break;
				}
			}
			//   AppStatus   -> 0            Activation Success (Registered copy)
			//   AppStatus   -> -1 to -5     error(Application status is Demo)
			//   AppStatus   -> -100         error(Application status is Demo)
			Module1.AppStatus = ErrorNo;
			//***
		}
		
		public void CmdOK_Click(System.Object sender, System.EventArgs e)
		{
			CheckActivation(TxtAct.Text, true);
			if (Module1.AppStatus != 0)
			{
				return;
			}
			this.Close();
		}
		
		public void CmdCancel_Click(System.Object sender, System.EventArgs e)
		{
			this.Close();
		}
	}
	
}
